Index: uspace/lib/bithenge/src/transform.c
===================================================================
--- uspace/lib/bithenge/src/transform.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/transform.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,5 +57,5 @@
  * within.
  * @return EOK or an error code from errno.h. */
-errno_t bithenge_init_transform(bithenge_transform_t *self,
+int bithenge_init_transform(bithenge_transform_t *self,
     const bithenge_transform_ops_t *ops, int num_params)
 {
@@ -83,5 +83,5 @@
  * @param[out] out Where the output tree will be stored.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_transform_apply(bithenge_transform_t *self,
+int bithenge_transform_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
@@ -94,5 +94,5 @@
 		return EINVAL;
 	aoff64_t self_size, whole_size;
-	errno_t rc = bithenge_transform_prefix_apply(self, scope,
+	int rc = bithenge_transform_prefix_apply(self, scope,
 	    bithenge_node_as_blob(in), out, &self_size);
 	if (rc != EOK)
@@ -119,5 +119,5 @@
  * @return EOK on success, ENOTSUP if not supported, or another error code from
  * errno.h. */
-errno_t bithenge_transform_prefix_length(bithenge_transform_t *self,
+int bithenge_transform_prefix_length(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_blob_t *blob, aoff64_t *out)
 {
@@ -130,5 +130,5 @@
 
 	bithenge_node_t *node;
-	errno_t rc = bithenge_transform_prefix_apply(self, scope, blob, &node,
+	int rc = bithenge_transform_prefix_apply(self, scope, blob, &node,
 	    out);
 	if (rc != EOK)
@@ -150,5 +150,5 @@
  * @return EOK on success, ENOTSUP if not supported, or another error code from
  * errno.h. */
-errno_t bithenge_transform_prefix_apply(bithenge_transform_t *self,
+int bithenge_transform_prefix_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_blob_t *blob, bithenge_node_t **out_node,
     aoff64_t *out_size)
@@ -163,5 +163,5 @@
 
 	aoff64_t size;
-	errno_t rc = bithenge_transform_prefix_length(self, scope, blob, &size);
+	int rc = bithenge_transform_prefix_length(self, scope, blob, &size);
 	if (rc != EOK)
 		return rc;
@@ -188,5 +188,5 @@
  * @param outer The outer scope, or NULL.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_scope_new(bithenge_scope_t **out, bithenge_scope_t *outer)
+int bithenge_scope_new(bithenge_scope_t **out, bithenge_scope_t *outer)
 {
 	bithenge_scope_t *self = malloc(sizeof(*self));
@@ -251,5 +251,5 @@
  * @param format The format string.
  * @return EINVAL normally, or another error code from errno.h. */
-errno_t bithenge_scope_error(bithenge_scope_t *scope, const char *format, ...)
+int bithenge_scope_error(bithenge_scope_t *scope, const char *format, ...)
 {
 	if (scope->error)
@@ -271,5 +271,5 @@
 		if (format[0] == '%' && format[1] == 't') {
 			format += 2;
-			errno_t rc = bithenge_print_node_to_string(&out,
+			int rc = bithenge_print_node_to_string(&out,
 			    &space_left, BITHENGE_PRINT_PYTHON,
 			    va_arg(ap, bithenge_node_t *));
@@ -364,5 +364,5 @@
  * @param num_params The number of parameters to allocate.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_scope_alloc_params(bithenge_scope_t *scope, int num_params)
+int bithenge_scope_alloc_params(bithenge_scope_t *scope, int num_params)
 {
 	scope->params = malloc(sizeof(*scope->params) * num_params);
@@ -382,5 +382,5 @@
  * @param node The value to store in the parameter.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_scope_set_param( bithenge_scope_t *scope, int i,
+int bithenge_scope_set_param( bithenge_scope_t *scope, int i,
     bithenge_node_t *node)
 {
@@ -401,5 +401,5 @@
  * @param[out] out Stores a new reference to the parameter.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_scope_get_param(bithenge_scope_t *scope, int i,
+int bithenge_scope_get_param(bithenge_scope_t *scope, int i,
     bithenge_node_t **out)
 {
@@ -436,10 +436,10 @@
 }
 
-static errno_t barrier_transform_apply(bithenge_transform_t *base,
+static int barrier_transform_apply(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
 	barrier_transform_t *self = transform_as_barrier(base);
 	bithenge_scope_t *inner_scope;
-	errno_t rc = bithenge_scope_new(&inner_scope, scope);
+	int rc = bithenge_scope_new(&inner_scope, scope);
 	if (rc != EOK)
 		return rc;
@@ -451,10 +451,10 @@
 }
 
-static errno_t barrier_transform_prefix_length(bithenge_transform_t *base,
+static int barrier_transform_prefix_length(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_blob_t *in, aoff64_t *out)
 {
 	barrier_transform_t *self = transform_as_barrier(base);
 	bithenge_scope_t *inner_scope;
-	errno_t rc = bithenge_scope_new(&inner_scope, scope);
+	int rc = bithenge_scope_new(&inner_scope, scope);
 	if (rc != EOK)
 		return rc;
@@ -467,5 +467,5 @@
 }
 
-static errno_t barrier_transform_prefix_apply(bithenge_transform_t *base,
+static int barrier_transform_prefix_apply(bithenge_transform_t *base,
     bithenge_scope_t *scope, bithenge_blob_t *in, bithenge_node_t **out_node,
     aoff64_t *out_length)
@@ -473,5 +473,5 @@
 	barrier_transform_t *self = transform_as_barrier(base);
 	bithenge_scope_t *inner_scope;
-	errno_t rc = bithenge_scope_new(&inner_scope, scope);
+	int rc = bithenge_scope_new(&inner_scope, scope);
 	if (rc != EOK)
 		return rc;
@@ -503,5 +503,5 @@
  * @param transform The subtransform to use for all operations.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_barrier_transform_set_subtransform(bithenge_transform_t *base,
+int bithenge_barrier_transform_set_subtransform(bithenge_transform_t *base,
     bithenge_transform_t *transform)
 {
@@ -527,7 +527,7 @@
  * @param num_params The number of parameters to require, which may be 0.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_barrier_transform(bithenge_transform_t **out, int num_params)
-{
-	errno_t rc;
+int bithenge_new_barrier_transform(bithenge_transform_t **out, int num_params)
+{
+	int rc;
 	barrier_transform_t *self = malloc(sizeof(*self));
 	if (!self) {
@@ -551,8 +551,8 @@
 /***************** ascii                                     *****************/
 
-static errno_t ascii_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int ascii_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_node_t *in, bithenge_node_t **out)
 {
-	errno_t rc;
+	int rc;
 	if (bithenge_node_type(in) != BITHENGE_NODE_BLOB)
 		return EINVAL;
@@ -596,5 +596,5 @@
 /***************** bit                                       *****************/
 
-static errno_t bit_prefix_apply(bithenge_transform_t *self,
+static int bit_prefix_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_blob_t *blob, bithenge_node_t **out_node,
     aoff64_t *out_size)
@@ -602,5 +602,5 @@
 	char buffer;
 	aoff64_t size = 1;
-	errno_t rc = bithenge_blob_read_bits(blob, 0, &buffer, &size, true);
+	int rc = bithenge_blob_read_bits(blob, 0, &buffer, &size, true);
 	if (rc != EOK)
 		return rc;
@@ -642,8 +642,8 @@
 }
 
-static errno_t bits_xe_size(bithenge_blob_t *base, aoff64_t *out)
+static int bits_xe_size(bithenge_blob_t *base, aoff64_t *out)
 {
 	bits_xe_blob_t *self = blob_as_bits_xe(base);
-	errno_t rc = bithenge_blob_size(self->bytes, out);
+	int rc = bithenge_blob_size(self->bytes, out);
 	*out *= 8;
 	return rc;
@@ -658,5 +658,5 @@
 }
 
-static errno_t bits_xe_read_bits(bithenge_blob_t *base, aoff64_t offset,
+static int bits_xe_read_bits(bithenge_blob_t *base, aoff64_t offset,
     char *buffer, aoff64_t *size, bool little_endian)
 {
@@ -676,5 +676,5 @@
 		bytes_buffer = (uint8_t *)buffer;
 
-	errno_t rc = bithenge_blob_read(self->bytes, bytes_offset,
+	int rc = bithenge_blob_read(self->bytes, bytes_offset,
 	    (char *)bytes_buffer, &bytes_size);
 	if (rc != EOK)
@@ -715,5 +715,5 @@
 };
 
-static errno_t bits_xe_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int bits_xe_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_node_t *in, bithenge_node_t **out)
 {
@@ -723,5 +723,5 @@
 	if (!blob)
 		return ENOMEM;
-	errno_t rc = bithenge_init_random_access_blob(bits_xe_as_blob(blob),
+	int rc = bithenge_init_random_access_blob(bits_xe_as_blob(blob),
 	    &bits_xe_blob_ops);
 	if (rc != EOK) {
@@ -757,5 +757,5 @@
 /***************** invalid                                   *****************/
 
-static errno_t invalid_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int invalid_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_node_t *in, bithenge_node_t **out)
 {
@@ -777,9 +777,9 @@
 /***************** known_length                              *****************/
 
-static errno_t known_length_apply(bithenge_transform_t *self,
+static int known_length_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
 	bithenge_node_t *length_node;
-	errno_t rc = bithenge_scope_get_param(scope, 0, &length_node);
+	int rc = bithenge_scope_get_param(scope, 0, &length_node);
 	if (rc != EOK)
 		return rc;
@@ -805,9 +805,9 @@
 }
 
-static errno_t known_length_prefix_length(bithenge_transform_t *self,
+static int known_length_prefix_length(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_blob_t *in, aoff64_t *out)
 {
 	bithenge_node_t *length_node;
-	errno_t rc = bithenge_scope_get_param(scope, 0, &length_node);
+	int rc = bithenge_scope_get_param(scope, 0, &length_node);
 	if (rc != EOK)
 		return rc;
@@ -834,5 +834,5 @@
 };
 
-static errno_t nonzero_boolean_apply(bithenge_transform_t *self,
+static int nonzero_boolean_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
@@ -853,5 +853,5 @@
 };
 
-static errno_t prefix_length_1(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int prefix_length_1(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_blob_t *blob, aoff64_t *out)
 {
@@ -860,5 +860,5 @@
 }
 
-static errno_t prefix_length_2(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int prefix_length_2(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_blob_t *blob, aoff64_t *out)
 {
@@ -867,5 +867,5 @@
 }
 
-static errno_t prefix_length_4(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int prefix_length_4(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_blob_t *blob, aoff64_t *out)
 {
@@ -874,5 +874,5 @@
 }
 
-static errno_t prefix_length_8(bithenge_transform_t *self, bithenge_scope_t *scope,
+static int prefix_length_8(bithenge_transform_t *self, bithenge_scope_t *scope,
     bithenge_blob_t *blob, aoff64_t *out)
 {
@@ -883,9 +883,9 @@
 /** @cond internal */
 #define MAKE_UINT_TRANSFORM(NAME, TYPE, ENDIAN, PREFIX_LENGTH_FUNC)            \
-	static errno_t NAME##_apply(bithenge_transform_t *self,                    \
+	static int NAME##_apply(bithenge_transform_t *self,                    \
 	    bithenge_scope_t *scope, bithenge_node_t *in,                      \
 	    bithenge_node_t **out)                                             \
 	{                                                                      \
-		errno_t rc;                                                        \
+		int rc;                                                        \
 		if (bithenge_node_type(in) != BITHENGE_NODE_BLOB)              \
 			return EINVAL;                                         \
@@ -927,5 +927,5 @@
 /***************** uint_be, uint_le                          *****************/
 
-static errno_t uint_xe_prefix_apply(bithenge_transform_t *self,
+static int uint_xe_prefix_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_blob_t *blob, bithenge_node_t **out_node,
     aoff64_t *out_size)
@@ -933,5 +933,5 @@
 	bool little_endian = (self == &bithenge_uint_le_transform);
 	bithenge_node_t *num_bits_node;
-	errno_t rc = bithenge_scope_get_param(scope, 0, &num_bits_node);
+	int rc = bithenge_scope_get_param(scope, 0, &num_bits_node);
 	if (rc != EOK)
 		return rc;
@@ -997,8 +997,8 @@
 /***************** zero_terminated                           *****************/
 
-static errno_t zero_terminated_apply(bithenge_transform_t *self,
+static int zero_terminated_apply(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_node_t *in, bithenge_node_t **out)
 {
-	errno_t rc;
+	int rc;
 	if (bithenge_node_type(in) != BITHENGE_NODE_BLOB)
 		return EINVAL;
@@ -1021,8 +1021,8 @@
 }
 
-static errno_t zero_terminated_prefix_length(bithenge_transform_t *self,
+static int zero_terminated_prefix_length(bithenge_transform_t *self,
     bithenge_scope_t *scope, bithenge_blob_t *blob, aoff64_t *out)
 {
-	errno_t rc;
+	int rc;
 	char buffer[4096];
 	aoff64_t offset = 0, size_read = sizeof(buffer);
Index: uspace/lib/bithenge/src/tree.c
===================================================================
--- uspace/lib/bithenge/src/tree.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/bithenge/src/tree.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -86,10 +86,10 @@
 } get_for_each_data_t;
 
-static errno_t get_for_each_func(bithenge_node_t *key, bithenge_node_t *value,
+static int get_for_each_func(bithenge_node_t *key, bithenge_node_t *value,
     void *raw_data)
 {
 	get_for_each_data_t *data = (get_for_each_data_t *)raw_data;
 	bool equal;
-	errno_t rc = bithenge_node_equal(&equal, key, data->key);
+	int rc = bithenge_node_equal(&equal, key, data->key);
 	bithenge_node_dec_ref(key);
 	if (rc != EOK)
@@ -113,5 +113,5 @@
  * @return EOK on success, ENOENT if not found, or another error code from
  * errno.h. */
-errno_t bithenge_node_get(bithenge_node_t *self, bithenge_node_t *key,
+int bithenge_node_get(bithenge_node_t *self, bithenge_node_t *key,
     bithenge_node_t **out)
 {
@@ -125,5 +125,5 @@
 		uint8_t byte;
 		aoff64_t size = 1;
-		errno_t rc = bithenge_blob_read(bithenge_node_as_blob(self),
+		int rc = bithenge_blob_read(bithenge_node_as_blob(self),
 		    offset, (char *)&byte, &size);
 		if (rc != EOK)
@@ -140,5 +140,5 @@
 	*out = NULL;
 	get_for_each_data_t data = {key, out};
-	errno_t rc = bithenge_node_for_each(self, get_for_each_func, &data);
+	int rc = bithenge_node_for_each(self, get_for_each_func, &data);
 	bithenge_node_dec_ref(key);
 	if (rc == EEXIST && *out)
@@ -155,5 +155,5 @@
  * @param[in] ops The operations provided.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_init_internal_node(bithenge_node_t *self,
+int bithenge_init_internal_node(bithenge_node_t *self,
     const bithenge_internal_node_ops_t *ops)
 {
@@ -169,5 +169,5 @@
 }
 
-static errno_t empty_internal_node_for_each(bithenge_node_t *base,
+static int empty_internal_node_for_each(bithenge_node_t *base,
     bithenge_for_each_func_t func, void *data)
 {
@@ -175,5 +175,5 @@
 }
 
-static errno_t empty_internal_node_get(bithenge_node_t *self, bithenge_node_t *key,
+static int empty_internal_node_get(bithenge_node_t *self, bithenge_node_t *key,
     bithenge_node_t **out)
 {
@@ -196,5 +196,5 @@
  * @param[out] out Holds the created node.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_empty_internal_node(bithenge_node_t **out)
+int bithenge_new_empty_internal_node(bithenge_node_t **out)
 {
 	if (bithenge_should_fail())
@@ -223,8 +223,8 @@
 }
 
-static errno_t simple_internal_node_for_each(bithenge_node_t *base,
+static int simple_internal_node_for_each(bithenge_node_t *base,
     bithenge_for_each_func_t func, void *data)
 {
-	errno_t rc;
+	int rc;
 	simple_internal_node_t *self = node_as_simple(base);
 	for (bithenge_int_t i = 0; i < self->len; i++) {
@@ -264,8 +264,8 @@
  * the nodes array rather than just dereferencing each node inside it.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_simple_internal_node(bithenge_node_t **out,
+int bithenge_new_simple_internal_node(bithenge_node_t **out,
     bithenge_node_t **nodes, bithenge_int_t len, bool needs_free)
 {
-	errno_t rc;
+	int rc;
 	assert(out);
 	simple_internal_node_t *self = malloc(sizeof(*self));
@@ -300,5 +300,5 @@
  * @param value The value for the node to hold.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_boolean_node(bithenge_node_t **out, bool value)
+int bithenge_new_boolean_node(bithenge_node_t **out, bool value)
 {
 	assert(out);
@@ -315,5 +315,5 @@
  * @param value The value for the node to hold.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_integer_node(bithenge_node_t **out, bithenge_int_t value)
+int bithenge_new_integer_node(bithenge_node_t **out, bithenge_int_t value)
 {
 	assert(out);
@@ -335,5 +335,5 @@
  * destroyed.
  * @return EOK on success or an error code from errno.h. */
-errno_t bithenge_new_string_node(bithenge_node_t **out, const char *value, bool needs_free)
+int bithenge_new_string_node(bithenge_node_t **out, const char *value, bool needs_free)
 {
 	assert(out);
@@ -359,5 +359,5 @@
  * @return EOK on success or an error code from errno.h.
  * @todo Add support for internal nodes. */
-errno_t bithenge_node_equal(bool *out, bithenge_node_t *a, bithenge_node_t *b)
+int bithenge_node_equal(bool *out, bithenge_node_t *a, bithenge_node_t *b)
 {
 	if (a->type != b->type) {
Index: uspace/lib/block/block.c
===================================================================
--- uspace/lib/block/block.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/block/block.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -52,5 +52,4 @@
 #include <stdio.h>
 #include <stacktrace.h>
-#include <str_error.h>
 #include <offset.h>
 #include <inttypes.h>
@@ -88,6 +87,6 @@
 } devcon_t;
 
-static errno_t read_blocks(devcon_t *, aoff64_t, size_t, void *, size_t);
-static errno_t write_blocks(devcon_t *, aoff64_t, size_t, void *, size_t);
+static int read_blocks(devcon_t *, aoff64_t, size_t, void *, size_t);
+static int write_blocks(devcon_t *, aoff64_t, size_t, void *, size_t);
 static aoff64_t ba_ltop(devcon_t *, aoff64_t);
 
@@ -107,5 +106,5 @@
 }
 
-static errno_t devcon_add(service_id_t service_id, async_sess_t *sess,
+static int devcon_add(service_id_t service_id, async_sess_t *sess,
     size_t bsize, aoff64_t dev_size, bd_t *bd)
 {
@@ -146,5 +145,5 @@
 }
 
-errno_t block_init(service_id_t service_id, size_t comm_size)
+int block_init(service_id_t service_id, size_t comm_size)
 {
 	bd_t *bd;
@@ -156,5 +155,5 @@
 	}
 	
-	errno_t rc = bd_open(sess, &bd);
+	int rc = bd_open(sess, &bd);
 	if (rc != EOK) {
 		async_hangup(sess);
@@ -209,8 +208,8 @@
 }
 
-errno_t block_bb_read(service_id_t service_id, aoff64_t ba)
+int block_bb_read(service_id_t service_id, aoff64_t ba)
 {
 	void *bb_buf;
-	errno_t rc;
+	int rc;
 
 	devcon_t *devcon = devcon_search(service_id);
@@ -270,5 +269,5 @@
 };
 
-errno_t block_cache_init(service_id_t service_id, size_t size, unsigned blocks,
+int block_cache_init(service_id_t service_id, size_t size, unsigned blocks,
     enum cache_mode mode)
 {
@@ -307,9 +306,9 @@
 }
 
-errno_t block_cache_fini(service_id_t service_id)
+int block_cache_fini(service_id_t service_id)
 {
 	devcon_t *devcon = devcon_search(service_id);
 	cache_t *cache;
-	errno_t rc;
+	int rc;
 
 	if (!devcon)
@@ -381,7 +380,7 @@
  *				device.
  *
- * @return			EOK on success or an error code.
- */
-errno_t block_get(block_t **block, service_id_t service_id, aoff64_t ba, int flags)
+ * @return			EOK on success or a negative error code.
+ */
+int block_get(block_t **block, service_id_t service_id, aoff64_t ba, int flags)
 {
 	devcon_t *devcon;
@@ -390,5 +389,5 @@
 	link_t *link;
 	aoff64_t p_ba;
-	errno_t rc;
+	int rc;
 	
 	devcon = devcon_search(service_id);
@@ -578,7 +577,7 @@
  * @param block		Block of which a reference is to be released.
  *
- * @return		EOK on success or an error code.
- */
-errno_t block_put(block_t *block)
+ * @return		EOK on success or a negative error code.
+ */
+int block_put(block_t *block)
 {
 	devcon_t *devcon = devcon_search(block->service_id);
@@ -586,5 +585,5 @@
 	unsigned blocks_cached;
 	enum cache_mode mode;
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	assert(devcon);
@@ -699,7 +698,7 @@
  * @param block_size	Block size to be used for the transfer.
  *
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_seqread(service_id_t service_id, void *buf, size_t *bufpos,
+ * @return		EOK on success or a negative return code on failure.
+ */
+int block_seqread(service_id_t service_id, void *buf, size_t *bufpos,
     size_t *buflen, aoff64_t *pos, void *dst, size_t size)
 {
@@ -735,5 +734,5 @@
 		if (*bufpos == *buflen) {
 			/* Refill the communication buffer with a new block. */
-			errno_t rc;
+			int rc;
 
 			rc = read_blocks(devcon, *pos / block_size, 1, buf,
@@ -758,7 +757,7 @@
  * @param src		Buffer for storing the data.
  *
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_read_direct(service_id_t service_id, aoff64_t ba, size_t cnt, void *buf)
+ * @return		EOK on success or negative error code on failure.
+ */
+int block_read_direct(service_id_t service_id, aoff64_t ba, size_t cnt, void *buf)
 {
 	devcon_t *devcon;
@@ -777,7 +776,7 @@
  * @param src		The data to be written.
  *
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_write_direct(service_id_t service_id, aoff64_t ba, size_t cnt,
+ * @return		EOK on success or negative error code on failure.
+ */
+int block_write_direct(service_id_t service_id, aoff64_t ba, size_t cnt,
     const void *data)
 {
@@ -796,7 +795,7 @@
  * @param cnt		Number of blocks.
  *
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_sync_cache(service_id_t service_id, aoff64_t ba, size_t cnt)
+ * @return		EOK on success or negative error code on failure.
+ */
+int block_sync_cache(service_id_t service_id, aoff64_t ba, size_t cnt)
 {
 	devcon_t *devcon;
@@ -813,7 +812,7 @@
  * @param bsize		Output block size.
  *
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_get_bsize(service_id_t service_id, size_t *bsize)
+ * @return		EOK on success or negative error code on failure.
+ */
+int block_get_bsize(service_id_t service_id, size_t *bsize)
 {
 	devcon_t *devcon;
@@ -830,7 +829,7 @@
  * @param nblocks	Output number of blocks.
  *
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_get_nblocks(service_id_t service_id, aoff64_t *nblocks)
+ * @return		EOK on success or negative error code on failure.
+ */
+int block_get_nblocks(service_id_t service_id, aoff64_t *nblocks)
 {
 	devcon_t *devcon = devcon_search(service_id);
@@ -847,10 +846,10 @@
  * @param data			Buffer that receives the data
  * 
- * @return		EOK on success or an error code on failure.
- */
-errno_t block_read_bytes_direct(service_id_t service_id, aoff64_t abs_offset,
+ * @return		EOK on success or negative error code on failure.
+ */
+int block_read_bytes_direct(service_id_t service_id, aoff64_t abs_offset,
     size_t bytes, void *data)
 {
-	errno_t rc;
+	int rc;
 	size_t phys_block_size;
 	size_t buf_size;
@@ -898,8 +897,8 @@
  *
  * @return Allocated TOC structure.
- * @return EOK on success or an error code.
- *
- */
-errno_t block_read_toc(service_id_t service_id, uint8_t session, void *buf,
+ * @return EOK on success or negative error code.
+ *
+ */
+int block_read_toc(service_id_t service_id, uint8_t session, void *buf,
     size_t bufsize)
 {
@@ -917,15 +916,15 @@
  * @param src		Buffer for storing the data.
  *
- * @return		EOK on success or an error code on failure.
- */
-static errno_t read_blocks(devcon_t *devcon, aoff64_t ba, size_t cnt, void *buf,
+ * @return		EOK on success or negative error code on failure.
+ */
+static int read_blocks(devcon_t *devcon, aoff64_t ba, size_t cnt, void *buf,
     size_t size)
 {
 	assert(devcon);
 	
-	errno_t rc = bd_read_blocks(devcon->bd, ba, cnt, buf, size);
+	int rc = bd_read_blocks(devcon->bd, ba, cnt, buf, size);
 	if (rc != EOK) {
-		printf("Error %s reading %zu blocks starting at block %" PRIuOFF64
-		    " from device handle %" PRIun "\n", str_error_name(rc), cnt, ba,
+		printf("Error %d reading %zu blocks starting at block %" PRIuOFF64
+		    " from device handle %" PRIun "\n", rc, cnt, ba,
 		    devcon->service_id);
 #ifndef NDEBUG
@@ -944,15 +943,15 @@
  * @param src		Buffer containing the data to write.
  *
- * @return		EOK on success or an error code on failure.
- */
-static errno_t write_blocks(devcon_t *devcon, aoff64_t ba, size_t cnt, void *data,
+ * @return		EOK on success or negative error code on failure.
+ */
+static int write_blocks(devcon_t *devcon, aoff64_t ba, size_t cnt, void *data,
     size_t size)
 {
 	assert(devcon);
 	
-	errno_t rc = bd_write_blocks(devcon->bd, ba, cnt, data, size);
+	int rc = bd_write_blocks(devcon->bd, ba, cnt, data, size);
 	if (rc != EOK) {
-		printf("Error %s writing %zu blocks starting at block %" PRIuOFF64
-		    " to device handle %" PRIun "\n", str_error_name(rc), cnt, ba, devcon->service_id);
+		printf("Error %d writing %zu blocks starting at block %" PRIuOFF64
+		    " to device handle %" PRIun "\n", rc, cnt, ba, devcon->service_id);
 #ifndef NDEBUG
 		stacktrace_print();
Index: uspace/lib/block/block.h
===================================================================
--- uspace/lib/block/block.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/block/block.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -85,5 +85,5 @@
 	/** Link for placing the block into the free block list. */
 	link_t free_link;
-	/** Link for placing the block into the block hash table. */
+	/** Link for placing the block into the block hash table. */ 
 	ht_link_t hash_link;
 	/** Buffer with the block data. */
@@ -99,26 +99,26 @@
 };
 
-extern errno_t block_init(service_id_t, size_t);
+extern int block_init(service_id_t, size_t);
 extern void block_fini(service_id_t);
 
-extern errno_t block_bb_read(service_id_t, aoff64_t);
+extern int block_bb_read(service_id_t, aoff64_t);
 extern void *block_bb_get(service_id_t);
 
-extern errno_t block_cache_init(service_id_t, size_t, unsigned, enum cache_mode);
-extern errno_t block_cache_fini(service_id_t);
+extern int block_cache_init(service_id_t, size_t, unsigned, enum cache_mode);
+extern int block_cache_fini(service_id_t);
 
-extern errno_t block_get(block_t **, service_id_t, aoff64_t, int);
-extern errno_t block_put(block_t *);
+extern int block_get(block_t **, service_id_t, aoff64_t, int);
+extern int block_put(block_t *);
 
-extern errno_t block_seqread(service_id_t, void *, size_t *, size_t *, aoff64_t *,
+extern int block_seqread(service_id_t, void *, size_t *, size_t *, aoff64_t *,
     void *, size_t);
 
-extern errno_t block_get_bsize(service_id_t, size_t *);
-extern errno_t block_get_nblocks(service_id_t, aoff64_t *);
-extern errno_t block_read_toc(service_id_t, uint8_t, void *, size_t);
-extern errno_t block_read_direct(service_id_t, aoff64_t, size_t, void *);
-extern errno_t block_read_bytes_direct(service_id_t, aoff64_t, size_t, void *);
-extern errno_t block_write_direct(service_id_t, aoff64_t, size_t, const void *);
-extern errno_t block_sync_cache(service_id_t, aoff64_t, size_t);
+extern int block_get_bsize(service_id_t, size_t *);
+extern int block_get_nblocks(service_id_t, aoff64_t *);
+extern int block_read_toc(service_id_t, uint8_t, void *, size_t);
+extern int block_read_direct(service_id_t, aoff64_t, size_t, void *);
+extern int block_read_bytes_direct(service_id_t, aoff64_t, size_t, void *);
+extern int block_write_direct(service_id_t, aoff64_t, size_t, const void *);
+extern int block_sync_cache(service_id_t, aoff64_t, size_t);
 
 #endif
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/Makefile	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -85,5 +85,4 @@
 	generic/str.c \
 	generic/str_error.c \
-	generic/strtol.c \
 	generic/l18n/langs.c \
 	generic/fibril.c \
Index: uspace/lib/c/arch/abs32le/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/abs32le/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/abs32le/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,10 +40,10 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	return 0;
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return 0;
Index: uspace/lib/c/arch/amd64/Makefile.common
===================================================================
--- uspace/lib/c/arch/amd64/Makefile.common	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/amd64/Makefile.common	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -31,8 +31,5 @@
 # XXX: clang doesn't support this flag, but the optimization is OS-specific,
 #      so it isn't used for amd64-unknown-elf target.
-
-ifneq ($(COMPILER),clang)
-	COMMON_CFLAGS += -mno-tls-direct-seg-refs
-endif
+GCC_CFLAGS += -mno-tls-direct-seg-refs
 
 LFLAGS += --gc-sections
Index: uspace/lib/c/arch/amd64/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/amd64/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/amd64/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,10 +49,10 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_FP_PREV, prev);
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_RA, ra);
Index: uspace/lib/c/arch/arm32/include/libarch/atomic.h
===================================================================
--- uspace/lib/c/arch/arm32/include/libarch/atomic.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/arm32/include/libarch/atomic.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -82,5 +82,5 @@
 	ras_page[1] = 0xffffffff;
 	
-	return ret != 0;
+	return (bool) ret;
 }
 
Index: uspace/lib/c/arch/arm32/src/stacktrace.c
===================================================================
--- uspace/lib/c/arch/arm32/src/stacktrace.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/arch/arm32/src/stacktrace.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,10 +49,10 @@
 }
 
-errno_t stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
+int stacktrace_fp_prev(stacktrace_t *st, uintptr_t fp, uintptr_t *prev)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_FP_PREV, prev);
 }
 
-errno_t stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
+int stacktrace_ra_get(stacktrace_t *st, uintptr_t fp, uintptr_t *ra)
 {
 	return (*st->ops->read_uintptr)(st->op_arg, fp + FRAME_OFFSET_RA, ra);
